## ros-humble-stubborn-buddies 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(stubborn_buddies)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(std_msgs REQUIRED)
find_package(stubborn_buddies_msgs REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
# uncomment the following section in order to fill in
# further dependencies manually.

include_directories(
  include
  ${lifecycle_msgs_INCLUDE_DIRS}
  ${rclcpp_lifecycle_INCLUDE_DIRS}
  ${rclcpp_INCLUDE_DIRS})

add_library(lifecycle_watchdog SHARED
  src/lifecycle_watchdog.cpp)
target_compile_definitions(lifecycle_watchdog
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(lifecycle_watchdog
  "rclcpp"
  "rclcpp_components"
  "std_msgs"
  "stubborn_buddies_msgs"
  "rclcpp_lifecycle")
rclcpp_components_register_nodes(lifecycle_watchdog "lifecycle_watchdog::LifecycleWatchdog")
set(node_plugins "${node_plugins}lifecycle_watchdog::LifecycleWatchdog;$<TARGET_FILE:lifecycle_watchdog>\n")

add_library(lifecycle_heartbeat SHARED
  src/lifecycle_heartbeat.cpp)
target_compile_definitions(lifecycle_heartbeat
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(lifecycle_heartbeat
  "rclcpp"
  "rclcpp_components"
  "std_msgs"
  "stubborn_buddies_msgs"
  "rclcpp_lifecycle")
rclcpp_components_register_nodes(lifecycle_heartbeat "lifecycle_heartbeat::LifecycleHeartbeat")
set(node_plugins "${node_plugins}lifecycle_heartbeat::LifecycleHeartbeat;$<TARGET_FILE:lifecycle_heartbeat>\n")

add_library(lifecycle_talker SHARED
  src/lifecycle_talker.cpp)
target_compile_definitions(lifecycle_talker
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(lifecycle_talker
  "rclcpp"
  "rclcpp_components"
  "std_msgs"
  "rclcpp_lifecycle"
  "stubborn_buddies_msgs")
rclcpp_components_register_nodes(lifecycle_talker "lifecycle_talker::LifecycleTalker")
set(node_plugins "${node_plugins}lifecycle_talker::LifecycleTalker;$<TARGET_FILE:lifecycle_talker>\n")

# since the package installs libraries without exporting them
# it needs to make sure that the library path is being exported
if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}")
endif()

add_executable(linktime_composition
  src/linktime_composition.cpp)

set(libs
  lifecycle_heartbeat
  lifecycle_watchdog
  lifecycle_talker)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(libs
    "-Wl,--no-as-needed"
    ${libs}
    "-Wl,--as-needed")
endif()

target_link_libraries(linktime_composition ${libs})
ament_target_dependencies(linktime_composition
  "class_loader"
  "rclcpp"
  "rclcpp_components")

#ament_export_include_directories(include)
ament_export_targets(lifecycle_heartbeat HAS_LIBRARY_TARGET)
ament_export_targets(lifecycle_watchdog HAS_LIBRARY_TARGET)
ament_export_dependencies(
  rclcpp 
  rclcpp_lifecycle
  stubborn_buddies_msgs
  rclcpp_components)

install(TARGETS
  lifecycle_heartbeat
  EXPORT lifecycle_heartbeat
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

install(TARGETS
  lifecycle_watchdog
  EXPORT lifecycle_watchdog
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

install(TARGETS
  lifecycle_talker
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

install(TARGETS
  linktime_composition
  DESTINATION lib/${PROJECT_NAME})

install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME})

ament_package()

=== debian/changelog ===
ros-humble-stubborn-buddies (1.0.0-5jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Marco A. Gutiérrez <marco@openrobotics.org>  Wed, 20 Apr 2022 03:10:23 -0000

=== debian/control ===
Source: ros-humble-stubborn-buddies
Section: misc
Priority: optional
Maintainer: Marco A. Gutiérrez <marco@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-rclcpp-lifecycle, ros-humble-rcutils, ros-humble-std-msgs, ros-humble-stubborn-buddies-msgs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-stubborn-buddies
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-rclcpp-lifecycle, ros-humble-rcutils, ros-humble-std-msgs, ros-humble-stubborn-buddies-msgs, ros-humble-ros-workspace
Description: Demo that uses node composition of lifecycle nodes to achieve fail-over robustness on ROS nodes

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-stubborn-buddies//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
